.386
.model flat, stdcall
option casemap :none

.nolist
include windows.inc
include kernel32.inc
include user32.inc
include gdi32.inc
include comdlg32.inc
include masm32.inc
include winspool.inc
.list

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib comdlg32.lib
includelib masm32.lib
includelib winspool.lib

IDD_MAIN  equ 1000
IDE_HWND  equ 1001
IDB_PRINT equ 1002

.const
  sz32770   db '#32770',0,0
  szTitle   db 'p2mPrintWindow demo',0
  szDocName db 'Window Contents',0

.code

.nolist
include isA.asm
.list

;----------------------------------------------------------
  even
  MoveWindowToFront proc hWnd:HWND
    local hWndPopup:HWND

    invoke GetLastActivePopup, hWnd
    mov hWndPopup, eax
    invoke BringWindowToTop, hWnd
    invoke IsIconic, hWndPopup
    .if eax != 0
      invoke ShowWindow, hWndPopup, SW_RESTORE
    .else
      invoke SetForegroundWindow, hWndPopup
    .endif
    ret
  MoveWindowToFront endp

;----------------------------------------------------------
  even
  GetPrinterName proc pszPrnName
    local pdlg:PRINTDLG

    mov eax,pszPrnName
    mov byte ptr [eax],0
    invoke RtlZeroMemory, addr pdlg, sizeof pdlg
    mov pdlg.lStructSize, sizeof pdlg
    mov pdlg.Flags, PD_RETURNDC or PD_RETURNDEFAULT
    invoke PrintDlg, addr pdlg
    .if eax != 0
      .if pdlg.hDevMode != NULL
        invoke GlobalLock, pdlg.hDevMode
        .if eax != 0
          invoke lstrcpy, pszPrnName, eax
          invoke GlobalUnlock, pdlg.hDevMode
        .endif
      .endif
    .endif
    .if pdlg.hDevMode != NULL
      invoke GlobalFree, pdlg.hDevMode
    .endif
    .if pdlg.hDevNames != NULL
      invoke GlobalFree, pdlg.hDevNames
    .endif
    ret
  GetPrinterName endp

;----------------------------------------------------------
  even
  GetPrinterDC proc dwOrientation:word
    local pdlg:PRINTDLG
    local szPrnName[64]:byte
    local hPrn:HANDLE
    local pDevMode:ptr DEVMODE
    local hdc:HDC

    mov hdc,0
    mov pDevMode,NULL
    invoke GetPrinterName, addr szPrnName
    lea eax,szPrnName
    .if byte ptr [eax] != 0
      invoke OpenPrinter, addr szPrnName, addr hPrn, NULL
       .if eax != 0
         invoke DocumentProperties, NULL, hPrn, addr szPrnName, NULL, NULL, 0
         .if eax != 0
           invoke GlobalAlloc, GPTR, eax
           .if eax != 0
             mov pDevMode,eax
             invoke DocumentProperties, NULL, hPrn, addr szPrnName, pDevMode, NULL, DM_OUT_BUFFER
             .if eax != IDCANCEL
               mov cx,dwOrientation
               mov eax,pDevMode
               mov (DEVMODE ptr [eax]).dmOrientation,cx
               or (DEVMODE ptr [eax]).dmFields,DM_ORIENTATION
               invoke DocumentProperties, NULL, hPrn, addr szPrnName,\
                        pDevMode, pDevMode, DM_IN_BUFFER or DM_OUT_BUFFER
             .else
               invoke GlobalFree, pDevMode
                mov pDevMode,NULL
             .endif
           .endif
         .endif
         invoke ClosePrinter, hPrn
       .endif
    .endif
    .if pDevMode != NULL
      invoke RtlZeroMemory, addr pdlg, sizeof pdlg
      mov pdlg.lStructSize, sizeof pdlg
      mov pdlg.Flags, PD_RETURNDC or PD_RETURNDEFAULT
      invoke PrintDlg, addr pdlg
      .if eax != 0
        invoke ResetDC, pdlg.hDC, pDevMode
        mov hdc,eax
      .endif
      invoke GlobalFree, pDevMode
      .if pdlg.hDevMode != NULL
        invoke GlobalFree, pdlg.hDevMode
      .endif
      .if pdlg.hDevNames != NULL
        invoke GlobalFree, pdlg.hDevNames
      .endif
    .endif
    mov eax,hdc
    ret
  GetPrinterDC endp

;----------------------------------------------------------
  even
  Create24BPPDIBSection proc hdc:HDC, iWidth:dword, iHeight:dword
    local bmi : BITMAPINFO
    local pb  : ptr byte

    invoke RtlZeroMemory, addr bmi, sizeof bmi
    mov bmi.bmiHeader.biSize,sizeof BITMAPINFOHEADER
    mov eax,iWidth
    mov bmi.bmiHeader.biWidth,eax
    mov eax,iHeight
    mov bmi.bmiHeader.biHeight,eax
    mov bmi.bmiHeader.biPlanes,1;
    mov bmi.bmiHeader.biBitCount,24;
    mov bmi.bmiHeader.biCompression,BI_RGB;
    invoke CreateDIBSection, hdc, addr bmi, DIB_RGB_COLORS, addr pb, NULL, 0
    ret
  Create24BPPDIBSection endp

;-------------------------------------------------------------------;
  even
  CalcPrnRect proc uses ebx edi esi, hdcPrn:HDC, hdcWnd:HDC, rcWnd:ptr RECT, rcPrn:ptr RECT
    local x1:dword
    local x2:dword
    local y1:dword
    local y2:dword
    local w:dword
    local h:dword

    mov esi,offset GetDeviceCaps

    push LOGPIXELSX
    push hdcWnd
    call esi
    mov x1,eax
    push LOGPIXELSX
    push hdcPrn
    call esi
    mov x2,eax
    .if eax > x1
      xchg eax,x1
      mov x2,eax
    .endif

    push LOGPIXELSY
    push hdcWnd
    call esi
    mov y1,eax
    push LOGPIXELSY
    push hdcPrn
    call esi
    mov y2,eax
    .if eax > y1
      xchg eax,y1
      mov y2,eax
    .endif
    mul x1
    mov ecx,eax
    mov eax,y1
    mul x2
    .if eax < ecx
      push y1
      pop  x1
      push y2
      pop  x2
    .endif

    mov ebx,rcWnd
    mov edi,rcPrn
    invoke MulDiv, (RECT ptr [ebx]).right, x1, x2
    mov (RECT ptr [edi]).right,eax
    push eax
    invoke MulDiv, (RECT ptr [ebx]).bottom, x1, x2
    mov (RECT ptr [edi]).bottom,eax
    pop x1
    mov y1,eax

    push HORZRES
    push hdcPrn
    call esi
    mov x2,eax
    mov ebx,eax

    push VERTRES
    push hdcPrn
    call esi
    mov y2,eax
    mov esi,eax

    cmp eax,y1
    jb  short @1
    mov eax,x2
    cmp eax,x1
    jae short @2
  @1:
    mov eax,x2
    .if eax > x1
      xchg eax,x1
      mov x2,eax
    .endif
    mov eax,y2
    .if eax > y1
      xchg eax,y1
      mov y2,eax
    .endif
    mul x1
    mov ecx,eax
    mov eax,y1
    mul x2
    .if eax < ecx
      push y1
      pop  x1
      push y2
      pop  x2
    .endif
    
    invoke MulDiv, (RECT ptr [edi]).right, x2, x1
    mov (RECT ptr [edi]).right,eax
    invoke MulDiv, (RECT ptr [edi]).bottom, x2, x1
    mov (RECT ptr [edi]).bottom,eax

  @2:
    mov eax,(RECT ptr [edi]).right
    sub ebx,eax
    sar ebx,1
    mov (RECT ptr [edi]).left,ebx

    mov eax,(RECT ptr [edi]).bottom
    sub esi,eax
    sar esi,1
    mov (RECT ptr [edi]).top,esi

    ret
  CalcPrnRect endp

;-------------------------------------------------------------------;
  even
  p2mPrintWindow proc hWnd:HWND
    local hdcPrn:HDC
    local hdcWnd:HDC
    local hdcMem:HDC
    local hbm:HBITMAP
    local hbmMem:HBITMAP
    local dibs:DIBSECTION
    local doci:DOCINFO
    local xPrn:dword
    local yPrn:dword
    local cxPrn:dword
    local cyPrn:dword
    local rcWnd:RECT
    local rcPrn:RECT

    invoke MoveWindowToFront, hWnd
    invoke GetWindowRect, hWnd, addr rcWnd
    neg rcWnd.left
    neg rcWnd.top
    invoke OffsetRect, addr rcWnd, rcWnd.left, rcWnd.top
    mov eax,rcWnd.right
    .if eax < rcWnd.bottom
      mov eax,DMORIENT_PORTRAIT
    .else
      mov eax,DMORIENT_LANDSCAPE 
    .endif
    push eax
    call GetPrinterDC
    .if eax != NULL
      mov hdcPrn, eax
      invoke GetWindowDC, hWnd
      .if eax != NULL
        mov hdcWnd, eax
        invoke Create24BPPDIBSection, hdcWnd, rcWnd.right, rcWnd.bottom
        .if eax != 0
          mov hbm,eax
          invoke GetObject, hbm, sizeof dibs, addr dibs
          .if eax != 0
            invoke CreateCompatibleDC, hdcWnd
            .if eax != NULL
              mov hdcMem,eax
              invoke SelectObject, hdcMem, hbm
              mov hbmMem,eax
              invoke BitBlt, hdcMem, 0, 0, rcWnd.right, rcWnd.bottom, hdcWnd, 0, 0, SRCCOPY
              invoke RtlZeroMemory, addr doci, sizeof doci
              mov doci.cbSize,sizeof doci
              mov doci.lpszDocName,offset szDocName
              invoke StartDoc, hdcPrn, addr doci
              .if eax > 0
                invoke StartPage, hdcPrn
                .if eax > 0
                  invoke CalcPrnRect, hdcPrn, hdcWnd, addr rcWnd, addr rcPrn
                  invoke StretchDIBits, hdcPrn,\
                           rcPrn.left, rcPrn.top, rcPrn.right, rcPrn.bottom,\
                           0, 0, rcWnd.right, rcWnd.bottom,\
                           dibs.dsBm.bmBits, addr dibs.dsBmih, DIB_RGB_COLORS, SRCCOPY
                  invoke EndPage, hdcPrn
                .endif
                invoke EndDoc, hdcPrn
              .endif
              invoke SelectObject, hdcMem, hbmMem
              invoke DeleteDC, hdcMem
            .endif
          .endif
          invoke DeleteObject, hbm
        .endif
        invoke ReleaseDC, hWnd, hdcWnd
      .endif
      invoke DeleteDC, hdcPrn
    .endif
    ret
  p2mPrintWindow endp

;-------------------------------------------------------------------;
  even
  gethwnd proc hDlg:HWND, id:dword
    local bSuccess:dword
    local buffer[16]:byte

    mov bSuccess,0
    invoke GetDlgItemInt, hDlg, id, addr bSuccess, 0
    .if bSuccess == 0
      invoke GetDlgItemText, hDlg, id, addr buffer, sizeof buffer
      invoke IsAsmHexStringA, addr buffer
      .if eax != 0
        push eax
        invoke lstrlen, eax
        pop  ecx
        mov  byte ptr [eax + ecx - 1],0
        invoke htodw, ecx
        jmp short @F
      .else
        invoke IsCHexStringA, addr buffer
        .if eax != 0
          add eax,2
          invoke htodw, eax
          jmp short @F
        .else
          xor eax,eax
        .endif
      .endif
    .else
  @@: .if eax == 0
        mov eax,hDlg
      .endif
    .endif
    push eax
    invoke IsWindow, eax
    .if eax != 0
      pop eax
    .endif
    ret
  gethwnd endp

;-------------------------------------------------------------------;
  even
  dlgproc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    .if uMsg == WM_INITDIALOG
      invoke GetDlgItem, hDlg, IDE_HWND
      invoke SendMessage, eax, EM_LIMITTEXT, 10, 0
      invoke SetDlgItemInt, hDlg, IDE_HWND, 0, 0
      invoke GetDlgItem, hDlg, IDB_PRINT
      invoke EnableWindow, eax, 1
    .elseif uMsg == WM_COMMAND
      mov eax,wParam
      shr eax,16
      .if wParam == IDOK
        invoke GetFocus
        push eax
        invoke GetDlgItem, hDlg, IDE_HWND
        pop ecx
        .if eax == ecx
          invoke GetDlgItem, hDlg, IDB_PRINT
          push eax
          invoke IsWindowEnabled, eax
          pop ecx
          .if eax != 0
            mov eax,BN_CLICKED
            shl eax,16
            add eax,IDB_PRINT
            invoke SendMessage, hDlg, WM_COMMAND, eax, ecx
          .endif
        .endif
      .elseif eax == BN_CLICKED
        invoke GetDlgItem, hDlg, IDB_PRINT
        mov ecx,wParam
        and ecx,0FFFFh
        .if (ecx == IDB_PRINT) && (eax == lParam)
          invoke gethwnd, hDlg, IDE_HWND
          invoke p2mPrintWindow, eax
        .endif
      .elseif eax == EN_CHANGE
        invoke GetDlgItem, hDlg, IDE_HWND
        mov ecx,wParam
        and ecx,0FFFFh
        .if (ecx == IDE_HWND) && (eax == lParam)
          invoke gethwnd, hDlg, IDE_HWND
          push eax
          invoke GetDlgItem, hDlg, IDB_PRINT
          push eax
          call EnableWindow
        .endif
      .endif
    .elseif uMsg == WM_CLOSE
      invoke EndDialog, hDlg, 0
    .endif
    xor eax, eax
    ret
  dlgproc endp

;-------------------------------------------------------------------;
  even
  start:
    invoke FindWindow, offset sz32770, offset szTitle
    push eax
    invoke IsWindow, eax
    pop ecx
    .if eax != 0
      invoke MoveWindowToFront, ecx
    .else
      invoke GetModuleHandle, eax
      invoke DialogBoxParam, eax, IDD_MAIN, 0, dlgproc, 0
    .endif
    invoke ExitProcess, 0

end start
